// Generated by CoffeeScript 1.9.1
var blueprintAPI, getParametersOf, legacyASTfrom1AAST, legacyHeadersCombinedFrom1A, legacyHeadersFrom1AHeaders, legacyRequestFrom1ARequest, legacyRequestsFrom1AExamples, legacyResourcesFrom1AResource, legacyResponseFrom1AResponse, legacyResponsesFrom1AExamples, markdown, objectHelper, trimLastNewline,
  hasProp = {}.hasOwnProperty;

blueprintAPI = require('./blueprint');

objectHelper = require('./object-helper');

markdown = require('./markdown');

trimLastNewline = function(s) {
  if (!s) {
    return;
  }
  if (s[s.length - 1] === '\n') {
    return s.slice(0, -1);
  } else {
    return s;
  }
};

legacyHeadersFrom1AHeaders = function(headers) {
  var header, key, legacyHeaders, ref;
  legacyHeaders = {};
  ref = objectHelper.ensureObjectOfObjects(headers) || {};
  for (key in ref) {
    if (!hasProp.call(ref, key)) continue;
    header = ref[key];
    if ((header != null ? header.value : void 0) != null) {
      legacyHeaders[key] = header.value;
    }
  }
  return legacyHeaders;
};

legacyHeadersCombinedFrom1A = function(resOrReq, action, resource) {
  var cascade, header, headers, i, key, len, ref, someHeaders;
  headers = {};
  cascade = [resource.headers, action.headers, resOrReq != null ? resOrReq.headers : void 0];
  for (i = 0, len = cascade.length; i < len; i++) {
    someHeaders = cascade[i];
    if (someHeaders) {
      ref = legacyHeadersFrom1AHeaders(someHeaders);
      for (key in ref) {
        if (!hasProp.call(ref, key)) continue;
        header = ref[key];
        headers[key] = header;
      }
    }
  }
  return headers;
};

legacyRequestsFrom1AExamples = function(action, resource) {
  var example, exampleId, exampleIndex, i, j, len, len1, ref, ref1, req, requests;
  requests = [];
  ref = action.examples || [];
  for (exampleIndex = i = 0, len = ref.length; i < len; exampleIndex = ++i) {
    example = ref[exampleIndex];
    ref1 = example.requests || [];
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      req = ref1[j];
      requests.push(legacyRequestFrom1ARequest(req, action, resource, exampleId = exampleIndex));
    }
  }
  if (requests.length < 1) {
    return [legacyRequestFrom1ARequest({}, action, resource, exampleId = 0)];
  }
  return requests;
};

legacyRequestFrom1ARequest = function(request, action, resource, exampleId) {
  var legacyRequest;
  if (exampleId == null) {
    exampleId = void 0;
  }
  legacyRequest = new blueprintAPI.Request({
    headers: legacyHeadersCombinedFrom1A(request, action, resource),
    exampleId: exampleId
  });
  if (request.description) {
    legacyRequest.description = trimLastNewline(request.description);
    legacyRequest.htmlDescription = trimLastNewline(markdown.toHtmlSync(request.description));
  } else {
    legacyRequest.description = '';
    legacyRequest.htmlDescription = '';
  }
  legacyRequest.reference = request.reference;
  legacyRequest.body = trimLastNewline(request.body) || '';
  legacyRequest.name = request.name || '';
  legacyRequest.schema = trimLastNewline(request.schema) || '';
  return legacyRequest;
};

legacyResponsesFrom1AExamples = function(action, resource) {
  var example, exampleId, exampleIndex, i, j, len, len1, ref, ref1, resp, responses;
  responses = [];
  ref = action.examples || [];
  for (exampleIndex = i = 0, len = ref.length; i < len; exampleIndex = ++i) {
    example = ref[exampleIndex];
    ref1 = example.responses || [];
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      resp = ref1[j];
      responses.push(legacyResponseFrom1AResponse(resp, action, resource, exampleId = exampleIndex));
    }
  }
  return responses;
};

legacyResponseFrom1AResponse = function(response, action, resource, exampleId) {
  var legacyResponse;
  if (exampleId == null) {
    exampleId = void 0;
  }
  legacyResponse = new blueprintAPI.Response({
    headers: legacyHeadersCombinedFrom1A(response, action, resource),
    exampleId: exampleId
  });
  if (response.description) {
    legacyResponse.description = trimLastNewline(response.description);
    legacyResponse.htmlDescription = trimLastNewline(markdown.toHtmlSync(response.description));
  } else {
    legacyResponse.description = '';
    legacyResponse.htmlDescription = '';
  }
  legacyResponse.reference = response.reference;
  legacyResponse.body = trimLastNewline(response.body) || '';
  legacyResponse.schema = trimLastNewline(response.schema) || '';
  legacyResponse.name = response.name || '';
  legacyResponse.status = response.name || '';
  return legacyResponse;
};

getParametersOf = function(obj) {
  var item, key, param, params, paramsObj;
  if (!obj) {
    return void 0;
  }
  params = [];
  paramsObj = objectHelper.ensureObjectOfObjects(obj.parameters);
  for (key in paramsObj) {
    if (!hasProp.call(paramsObj, key)) continue;
    param = paramsObj[key];
    param.key = key;
    if (param.description) {
      param.description = markdown.toHtmlSync(param.description);
    }
    param.values = (function() {
      var i, len, ref, results;
      ref = param.values;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        results.push(typeof item === 'string' ? item : item.value);
      }
      return results;
    })();
    params.push(param);
  }
  if (!params.length) {
    return void 0;
  } else {
    return params;
  }
};

legacyResourcesFrom1AResource = function(legacyUrlConverterFn, resource) {
  var action, actionIndex, i, legacyResource, legacyResources, len, ref, ref1, ref2, ref3, requests, resourceParameters;
  legacyResources = [];
  resourceParameters = getParametersOf(resource);
  ref = resource.actions || [];
  for (actionIndex = i = 0, len = ref.length; i < len; actionIndex = ++i) {
    action = ref[actionIndex];
    legacyResource = new blueprintAPI.Resource({
      responses: [],
      requests: []
    });
    legacyResource.url = legacyUrlConverterFn(resource.uriTemplate);
    legacyResource.uriTemplate = resource.uriTemplate;
    legacyResource.method = action.method;
    legacyResource.name = ((ref1 = resource.name) != null ? ref1.trim() : void 0) || '';
    legacyResource.headers = legacyHeadersFrom1AHeaders(resource.headers);
    legacyResource.actionHeaders = legacyHeadersFrom1AHeaders(action.headers);
    legacyResource.description = trimLastNewline(resource.description);
    if ((ref2 = resource.description) != null ? ref2.length : void 0) {
      legacyResource.htmlDescription = trimLastNewline(markdown.toHtmlSync(resource.description.trim()));
    } else {
      legacyResource.htmlDescription = '';
    }
    if ((ref3 = action.name) != null ? ref3.length : void 0) {
      legacyResource.actionName = action.name.trim();
    } else {
      legacyResource.actionName = '';
    }
    if (!!resource.model) {
      legacyResource.model = resource.model;
      if (resource.model.description && resource.model.description.length) {
        legacyResource.model.description = markdown.toHtmlSync(resource.model.description);
      }
      if (resource.model.headers && resource.model.headers.length) {
        legacyResource.model.headers = legacyHeadersFrom1AHeaders(resource.model.headers);
      }
    } else {
      legacyResource.model = {};
    }
    legacyResource.resourceParameters = resourceParameters;
    legacyResource.actionParameters = getParametersOf(action);
    legacyResource.parameters = legacyResource.actionParameters || resourceParameters || void 0;
    if (action.description) {
      legacyResource.actionDescription = trimLastNewline(action.description);
      legacyResource.actionHtmlDescription = trimLastNewline(markdown.toHtmlSync(action.description));
    } else {
      legacyResource.actionDescription = '';
      legacyResource.actionHtmlDescription = '';
    }
    requests = legacyRequestsFrom1AExamples(action, resource);
    legacyResource.requests = requests;
    legacyResource.request = requests[0];
    legacyResource.responses = legacyResponsesFrom1AExamples(action, resource);
    legacyResources.push(legacyResource);
  }
  return legacyResources;
};

legacyASTfrom1AAST = function(ast, warnings, cb) {
  var i, j, legacyAST, legacySection, legacyUrlConverter, len, len1, metaKey, metaVal, metadata, ref, ref1, ref2, ref3, resource, resourceGroup, resourceGroupDescription, resources, slashIndex, urlPrefix, urlWithoutProtocol;
  legacyAST = new blueprintAPI.Blueprint({
    name: ast.name,
    version: blueprintAPI.Version,
    metadata: []
  });
  legacyAST.description = ("" + ast.description).trim() || '';
  legacyAST.htmlDescription = trimLastNewline(markdown.toHtmlSync(ast.description));
  metadata = [];
  ref = objectHelper.ensureObjectOfObjects(ast.metadata);
  for (metaKey in ref) {
    if (!hasProp.call(ref, metaKey)) continue;
    metaVal = ref[metaKey];
    if (metaKey === 'HOST') {
      legacyAST.location = metaVal.value;
      continue;
    }
    metadata.push({
      name: metaKey,
      value: metaVal.value
    });
  }
  if (metadata.length > 0) {
    legacyAST.metadata = metadata;
  }
  legacyUrlConverter = function(url) {
    return url;
  };
  if (legacyAST.location) {
    urlWithoutProtocol = legacyAST.location.replace(/^https?:\/\//, "");
    slashIndex = urlWithoutProtocol.indexOf("/");
    if (slashIndex > 0) {
      urlPrefix = urlWithoutProtocol.slice(slashIndex + 1);
      if (urlPrefix !== "") {
        urlPrefix = urlPrefix.replace(/\/$/, "");
        legacyUrlConverter = function(url) {
          return "/" + urlPrefix + "/" + url.replace(/^\//, "");
        };
      }
    }
  }
  ref1 = ast.resourceGroups;
  for (i = 0, len = ref1.length; i < len; i++) {
    resourceGroup = ref1[i];
    legacySection = new blueprintAPI.Section({
      name: resourceGroup.name,
      resources: []
    });
    resourceGroupDescription = (ref2 = resourceGroup.description) != null ? ref2.trim() : void 0;
    if (resourceGroupDescription) {
      legacySection.description = trimLastNewline(resourceGroupDescription);
      legacySection.htmlDescription = trimLastNewline(markdown.toHtmlSync(resourceGroupDescription));
    } else {
      legacySection.description = '';
      legacySection.htmlDescription = '';
    }
    ref3 = resourceGroup.resources;
    for (j = 0, len1 = ref3.length; j < len1; j++) {
      resource = ref3[j];
      resources = legacyResourcesFrom1AResource(legacyUrlConverter, resource);
      legacySection.resources = legacySection.resources.concat(resources);
    }
    legacyAST.sections.push(legacySection);
  }
  return cb(null, legacyAST, warnings);
};

module.exports = {
  transform: legacyASTfrom1AAST
};
