// Generated by CoffeeScript 1.9.1
var _, flags, parseMarkdown, parser, parserSync, renderer, rs, sanitizer, toHtml, toHtmlSync, uriPolicy;

_ = require('underscore');

rs = require('robotskirt');

sanitizer = require('sanitizer');

renderer = new rs.HtmlRenderer();

flags = [rs.EXT_AUTOLINK, rs.EXT_FENCED_CODE, rs.EXT_LAX_HTML_BLOCKS, rs.EXT_TABLES, rs.EXT_NO_INTRA_EMPHASIS, rs.EXT_STRIKETHROUGH, rs.EXT_SUPERSCRIPT];

parser = new rs.Markdown(renderer, flags);

parserSync = new rs.Markdown(renderer, flags);

uriPolicy = function(value) {
  return value;
};

parseMarkdown = function(markdown, options) {
  var parsed, results;
  if (options == null) {
    options = {};
  }
  if (!markdown) {
    return '';
  }
  if (options.sanitize == null) {
    options.sanitize = true;
  }
  parsed = parserSync.render(markdown);
  if (options.sanitize) {
    results = sanitizer.sanitize(parsed, uriPolicy);
  } else {
    results = parsed;
  }
  if (results.trim() !== '') {
    return results;
  }
  return '<span></span>';
};

toHtml = function(markdown, options, cb) {
  var ref;
  if (options == null) {
    options = {};
  }
  if (_.isFunction(options)) {
    ref = [options, {}], cb = ref[0], options = ref[1];
  }
  if (!markdown) {
    return cb(null, '');
  }
  return cb(null, parseMarkdown(markdown, options));
};

toHtmlSync = function(markdown, options) {
  if (options == null) {
    options = {};
  }
  return parseMarkdown(markdown, options);
};

module.exports = {
  toHtml: toHtml,
  toHtmlSync: toHtmlSync
};
